︠921ef0e7-94c0-4385-bff4-ad4ea5484cf8i︠
%html
<p><span style="font-size: small;">Durant ce TP, nous allons implanter diff&eacute;rents tests de primalit&eacute; et tenter de les comparer. Pour comparer deux tests, le temps utilis&eacute; est important, mais aussi la m&eacute;moire (est-ce que j'utilise des tableaux immenses, des entiers trop grands ?). En g&eacute;n&eacute;ral, les meilleurs algorithmes sont des compromis entre m&eacute;moire et temps. Pour chaque question, vous pouvez faire quelques tests rapides &agrave; chaque fois : jusqu'&agrave; quelle taille d'entiers est-ce qu'on g&egrave;re en moins d'une minute et sans avoir des bugs de d&eacute;passement de m&eacute;moire ? (Faites-le sur plus d'un exemple : en g&eacute;n&eacute;ral, si on essaie sur un entier pair ou multiple de 3, &ccedil;a va tr&egrave;s vite, mais on explose sur un nombre premier)<br /></span></p>
<p><span style="font-size: small;">Exercice 1 : &Eacute;chauffement.</span></p>
<p><span style="font-size: small;">Parce qu'il faut bien commencer par le d&eacute;but : &Eacute;crivez une fonction ForceBrute(n) qui teste si n est divisible par au moins un entier k&lt;n (quand peut-on s'arr&ecirc;ter ?).</span></p>

︡4e2ae898-20f6-406f-b56c-c1c034c7ce17︡{"html": "<p><span style=\"font-size: small;\">Durant ce TP, nous allons implanter diff&eacute;rents tests de primalit&eacute; et tenter de les comparer. Pour comparer deux tests, le temps utilis&eacute; est important, mais aussi la m&eacute;moire (est-ce que j'utilise des tableaux immenses, des entiers trop grands ?). En g&eacute;n&eacute;ral, les meilleurs algorithmes sont des compromis entre m&eacute;moire et temps. Pour chaque question, vous pouvez faire quelques tests rapides &agrave; chaque fois : jusqu'&agrave; quelle taille d'entiers est-ce qu'on g&egrave;re en moins d'une minute et sans avoir des bugs de d&eacute;passement de m&eacute;moire ? (Faites-le sur plus d'un exemple : en g&eacute;n&eacute;ral, si on essaie sur un entier pair ou multiple de 3, &ccedil;a va tr&egrave;s vite, mais on explose sur un nombre premier)<br /></span></p>\n<p><span style=\"font-size: small;\">Exercice 1 : &Eacute;chauffement.</span></p>\n<p><span style=\"font-size: small;\">Parce qu'il faut bien commencer par le d&eacute;but : &Eacute;crivez une fonction ForceBrute(n) qui teste si n est divisible par au moins un entier k&lt;n (quand peut-on s'arr&ecirc;ter ?).</span></p>"}︡
︠2c3d7f9a-4000-4095-89f0-0a69b9a7becb︠
def ForceBrute(n):
    for k in range(sqrt(n)):
        if n%k==0: return False
    return True
︡99f4f6e8-1416-4184-a98a-7682be266271︡{"stdout": "False"}︡
︠a0d7eb04-de35-4298-96e4-3e3f6c1d3dcei︠
%html
<p><span style="font-size: small;">Exercice 2 : Th&eacute;or&egrave;me de Wilson.</span></p>
<p><span style="font-size: small;">On a vu en cours que n est premier si et seulement si (n-1)! = 1 [n]. Construisez un test Wilson(n) qui utilise ce r&eacute;sultat pour tester si n est premier.</span></p>

︡40a0800e-cf1f-470a-a9af-0447d6a1d68b︡{"html": "<p><span style=\"font-size: small;\">Exercice 2 : Th&eacute;or&egrave;me de Wilson.</span></p>\n<p><span style=\"font-size: small;\">On a vu en cours que n est premier si et seulement si (n-1)! = 1 [n]. Construisez un test Wilson(n) qui utilise ce r&eacute;sultat pour tester si n est premier.</span></p>"}︡
︠a1058815-1b05-43f7-bc16-33ef7d6d3f1d︠
def Wilson(n) :
    fact = 1
    for k in range(2,n):
        fact = (fact*k)%n
    return (fact == n-1)
︡ea5179f4-b5c1-4482-a73b-6f8930689920︡︡
︠dc1f4a44-ad71-435a-8bce-f7f3ea0f6951i︠
%html
<p><span style="font-size: small;">Exercice 3 : Petit th&eacute;or&egrave;me de Fermat.</span></p>
<!-- 		@page { margin: 2cm } 		P { margin-bottom: 0.21cm } -->
<p><span style="font-size: small;">On sait que si p est premier, alors pour tout a, a<sup>p-1</sup>=1 [p]. L'inverse n'est pas toujours vrai, mais on peut esp&eacute;rer rep&eacute;rer des nombres non premiers comme &ccedil;a. &Eacute;crivez une fonction Fermat(n) qui :</span></p>
<p><span style="font-size: small;">- prend un entier a au hasard entre 2 et n-1 ;</span></p>
<p style="margin-bottom: 0cm;"><span style="font-size: small;">- teste si a<sup>n-1</sup>=1 [n] ;</span></p>
<p style="margin-bottom: 0cm"><span style="font-size: small;">- renvoie True si n est potentiellement premier, False sinon.</span></p>
<p style="margin-bottom: 0cm"><span style="font-size: small;">Pour la premi&egrave;re partie, on pourra utiliser randint(a,b) qui renvoie un entier entre a et b.&nbsp; <br /></span></p>

︡b2c22d5f-f928-4a27-9069-28d61bc3a65a︡{"html": "<p><span style=\"font-size: small;\">Exercice 3 : Petit th&eacute;or&egrave;me de Fermat.</span></p>\n<!-- \t\t@page { margin: 2cm } \t\tP { margin-bottom: 0.21cm } -->\n<p><span style=\"font-size: small;\">On sait que si p est premier, alors pour tout a, a<sup>p-1</sup>=1 [p]. L'inverse n'est pas toujours vrai, mais on peut esp&eacute;rer rep&eacute;rer des nombres non premiers comme &ccedil;a. &Eacute;crivez une fonction Fermat(n) qui :</span></p>\n<p><span style=\"font-size: small;\">- prend un entier a au hasard entre 2 et n-1 ;</span></p>\n<p style=\"margin-bottom: 0cm;\"><span style=\"font-size: small;\">- teste si a<sup>n-1</sup>=1 [n] ;</span></p>\n<p style=\"margin-bottom: 0cm\"><span style=\"font-size: small;\">- renvoie True si n est potentiellement premier, False sinon.</span></p>\n<p style=\"margin-bottom: 0cm\"><span style=\"font-size: small;\">Pour la premi&egrave;re partie, on pourra utiliser randint(a,b) qui renvoie un entier entre a et b.&nbsp; <br /></span></p>"}︡
︠92e15a9e-acaa-4d1c-90f0-c1f320bc0263︠
def Fermat(n):
    a = randint(2,n-1)
    res = 1
    for k in range(n-1):
        res = res*a%n
    return (res == 1)
︡dff85c86-00b2-4e5e-b1cf-1920bff6b67d︡︡
︠c4d96015-478d-4052-8435-6319464287fci︠
%html
<p><span style="font-size: small;">Exercice 4 : Exponentiation rapide.</span></p>
<!-- 		@page { margin: 2cm } 		P { margin-bottom: 0.21cm } -->
<p><span style="font-size: small;">On veut acc&eacute;l&eacute;rer l'algorithme pr&eacute;c&eacute;dent (j'esp&egrave;re que vous n'avez pas fait a**(n-1) ?) en &eacute;tant plus efficace sur le calcul de la puissance. &Eacute;crire une fonction ExpoRapide(a,k,n) qui calcule </span><span style="font-size: small;">a<sup>k </sup>[n] en distinguant les cas :</span></p>
<!-- 		@page { margin: 2cm } 		P { margin-bottom: 0.21cm } --><!-- 		@page { margin: 2cm } 		P { margin-bottom: 0.21cm } --><!-- 		@page { margin: 2cm } 		P { margin-bottom: 0.21cm } --><!-- 		@page { margin: 2cm } 		P { margin-bottom: 0.21cm } -->
<p><span style="font-size: small;">- Si k est pair, on fait a<sup>k</sup> = a<sup>k/2</sup>&nbsp; * a<sup>k/2</sup>;</span></p>
<!-- 		@page { margin: 2cm } 		P { margin-bottom: 0.21cm } -->
<p><span style="font-size: small;">- Si k est impair, on fait a<sup>k </sup>= a * a<sup>(k-1)/2</sup> * a<sup>(k-1)/2</sup></span></p>
<p><span style="font-size: small;">On peut par exemple utiliser la r&eacute;cursion en appelant la fonction qu'on est en train d'&eacute;crire (sans oublier de faire attention &agrave; ce qui se passe pour k=1).</span></p>

︡9b9bd0c5-2563-4a3c-8199-258e10ad7054︡{"html": "<p><span style=\"font-size: small;\">Exercice 4 : Exponentiation rapide.</span></p>\n<!-- \t\t@page { margin: 2cm } \t\tP { margin-bottom: 0.21cm } -->\n<p><span style=\"font-size: small;\">On veut acc&eacute;l&eacute;rer l'algorithme pr&eacute;c&eacute;dent (j'esp&egrave;re que vous n'avez pas fait a**(n-1) ?) en &eacute;tant plus efficace sur le calcul de la puissance. &Eacute;crire une fonction ExpoRapide(a,k,n) qui calcule </span><span style=\"font-size: small;\">a<sup>k </sup>[n] en distinguant les cas :</span></p>\n<!-- \t\t@page { margin: 2cm } \t\tP { margin-bottom: 0.21cm } --><!-- \t\t@page { margin: 2cm } \t\tP { margin-bottom: 0.21cm } --><!-- \t\t@page { margin: 2cm } \t\tP { margin-bottom: 0.21cm } --><!-- \t\t@page { margin: 2cm } \t\tP { margin-bottom: 0.21cm } -->\n<p><span style=\"font-size: small;\">- Si k est pair, on fait a<sup>k</sup> = a<sup>k/2</sup>&nbsp; * a<sup>k/2</sup>;</span></p>\n<!-- \t\t@page { margin: 2cm } \t\tP { margin-bottom: 0.21cm } -->\n<p><span style=\"font-size: small;\">- Si k est impair, on fait a<sup>k </sup>= a * a<sup>(k-1)/2</sup> * a<sup>(k-1)/2</sup></span></p>\n<p><span style=\"font-size: small;\">On peut par exemple utiliser la r&eacute;cursion en appelant la fonction qu'on est en train d'&eacute;crire (sans oublier de faire attention &agrave; ce qui se passe pour k=1).</span></p>"}︡
︠17752aad-2672-4bf1-a3ed-338826a08438︠
def ExpoRapide(a,k,n):
    if k==1: return a%n
    if k%2==0:
        b = ExpoRapide(a,k/2,n)
        return (b*b)%n
    b = ExpoRapide(a,(k-1)/2,n)
    return a*(b*b)%n
︡b46d4c05-d83c-41da-9886-30eddba240c8︡︡
︠a04a22cd-e754-4ec8-9619-b4b080a03655i︠
%html
<p><span style="font-size: small;">Exercice 5 : D&eacute;marche scientifique.</span></p>
<p><span style="font-size: small;">On aimerait avoir une id&eacute;e du taux d'erreur de l'algorithme pr&eacute;c&eacute;dent (nombres non premiers pour lesquels la r&eacute;ponse est True), par exemple pour les entiers &agrave; 5 chiffres. On peut tester sur tous les nombres de 1000 &agrave; 9999...(non conseill&eacute;), ou bien en prendre quelques centaines au hasard. &Eacute;crivez une fonction TestFermat() qui it&egrave;re cette op&eacute;ration jusqu'&agrave; ce qu'on ait atteint 10 erreurs (environ 2 minutes). Quel est la probabilit&eacute; de r&eacute;ussite du test ?<br /></span></p>

︡d5297be4-ac02-4baf-ab79-ce17a0d9d17e︡{"html": "<p><span style=\"font-size: small;\">Exercice 5 : D&eacute;marche scientifique.</span></p>\n<p><span style=\"font-size: small;\">On aimerait avoir une id&eacute;e du taux d'erreur de l'algorithme pr&eacute;c&eacute;dent (nombres non premiers pour lesquels la r&eacute;ponse est True), par exemple pour les entiers &agrave; 5 chiffres. On peut tester sur tous les nombres de 1000 &agrave; 9999...(non conseill&eacute;), ou bien en prendre quelques centaines au hasard. &Eacute;crivez une fonction TestFermat() qui it&egrave;re cette op&eacute;ration jusqu'&agrave; ce qu'on ait atteint 10 erreurs (environ 2 minutes). Quel est la probabilit&eacute; de r&eacute;ussite du test ?<br /></span></p>"}︡
︠3b6bb43c-d136-4461-92df-044ca16350c6︠
def TestFermat():
    compteur, erreurs = 0,0
    while erreurs<10:
        compteur +=1
        n = randint(1000,9999)
        if Fermat(n) != Wilson(n):
            erreurs +=1
    return (erreurs/compteur)
︡cedcf89d-ece8-42f0-9173-aab2c24132e9︡{"stdout": "10/2851"}︡
︠2926d67c-6f83-4a99-bfab-8e44ff120cfbi︠
%html
<p><span style="font-size: small;">Exercice 6 : <br /></span></p>
<p><span style="font-size: small;">Plut&ocirc;t que de prendre la valeur de a au hasard, on peut prendre a=2. Quel serait l'inter&ecirc;t en termes de vitesse ? &Eacute;crivez le programme Fermat2(n), puis testez sa probabilit&eacute; d'erreur sur toutes les valeurs de 1 &agrave; 10000. <br /></span></p>

︡296fbe1e-8ecb-4311-832e-8e8c27444755︡{"html": "<p><span style=\"font-size: small;\">Exercice 6 : <br /></span></p>\n<p><span style=\"font-size: small;\">Plut&ocirc;t que de prendre la valeur de a au hasard, on peut prendre a=2. Quel serait l'inter&ecirc;t en termes de vitesse ? &Eacute;crivez le programme Fermat2(n), puis testez sa probabilit&eacute; d'erreur sur toutes les valeurs de 1 &agrave; 10000. <br /></span></p>"}︡
︠8d056ddc-12fb-4df1-95bb-b4b94e46eb62︠
def Fermat2(n):
    res = 1
    for k in range(n-1):
        res = 2*res%n
    return (res == 1)
︡9fb93438-795f-436c-9900-b2d93a728b30︡︡
︠e99d8551-3b3b-4b5b-85a0-8978cc8a638b︠
def TestFermat2():
    compteur, erreurs = 0,0
    while erreurs<10:
        compteur +=1
        n = randint(1000,9999)
        if Fermat2(n) != Wilson(n):
            erreurs +=1
    return (erreurs/compteur)
︡a544e3eb-97f5-49ec-9130-fbefa42e41e7︡︡
︠62480c04-be1c-4318-8017-1df56970add4i︠
%html
<p><span style="font-size: small;">Exercice 7 : Notez que sur une entr&eacute;e donn&eacute;e, la r&eacute;ponse du programme pr&eacute;c&eacute;dent n'est pas al&eacute;atoire. Comment faire pour en tirer un programme qui ne commette aucune erreur sur les entr&eacute;es &lt;10000 ?</span></p>

︡b1deb0a1-26d1-4c3c-9dae-a9f141f592f2︡{"html": "<p><span style=\"font-size: small;\">Exercice 7 : Notez que sur une entr&eacute;e donn&eacute;e, la r&eacute;ponse du programme pr&eacute;c&eacute;dent n'est pas al&eacute;atoire. Comment faire pour en tirer un programme qui ne commette aucune erreur sur les entr&eacute;es &lt;10000 ?</span></p>"}︡
︠37b6b615-fe6b-48c3-b3f0-292c53278380︠
l = []
for k in range(10000):
    if Fermat2(k) != Wilson(k):
        l.append(k)
l
︡654656a0-22bd-4f75-863d-88a757b35df1︡{"stdout": "[0, 1, 2, 341, 561, 645, 1105, 1387, 1729, 1905, 2047, 2465, 2701, 2821, 3277, 4033, 4369, 4371, 4681, 5461, 6601, 7957, 8321, 8481, 8911]"}︡
︠41ca2031-e5b4-48a7-b1b5-2049c9f81790︠
def FermatExact(n):
    if n in l: return False
    else : return Fermat2(n)
︡e3b9115d-9dec-4781-ac87-021e902d1a24︡︡
︠23d8c267-b0c1-4d60-b3de-bb4f0b1d4b11i︠
%html
<p><span style="font-size: small;">Exercice 8 : factorisation de Pollard p-1<br /></span></p>
<p><span style="font-size: small;">On suppose n=pq, avec p,q premiers. On se donne B une borne assez grande et 1&lt;g&lt;n un nombre quelconque 'testeur'. On suppose que tous les facteurs de p-1 sont plus petits que B, de telle sorte que (p-1) divise B!. On&nbsp; consid&egrave;re alors a=g^(B!) mod n, qui doit &ecirc;tre congru &agrave; 1 modulo p, par le petit th&eacute;or&egrave;me de Fermat. Ainsi p divise (a-1) et n, donc le pgcd(a-1,n), s'il est diff&eacute;rent de 1 et n, est un diviseur non trivial de n. On a factoris&eacute; n.&nbsp;&nbsp; </span></p>
<p><span style="font-size: small;">&Eacute;crire une procedure PollardTest(n,B,g) qui effectue l'algorithme (p-1) de Pollard pour le nombre testeur g.&nbsp; Puis &eacute;crire une procedure Pollard(n,B) qui&nbsp; effectue les tests de Pollard avec tous les testeurs g tels que 1&lt;g&lt;n et s'arr&ecirc;te si elle trouve un facteur de n ou si tous les g possibles ont &eacute;t&eacute; test&eacute;s.&nbsp; Appliquer cette proc&eacute;dure sur n = 139*197 et retrouver p,q. <br /></span></p>

︡4ea469e2-0b4c-4bdc-ae44-621dbafcb5c8︡{"html": "<p><span style=\"font-size: small;\">Exercice 8 : factorisation de Pollard p-1<br /></span></p>\n<p><span style=\"font-size: small;\">On suppose n=pq, avec p,q premiers. On se donne B une borne assez grande et 1&lt;g&lt;n un nombre quelconque 'testeur'. On suppose que tous les facteurs de p-1 sont plus petits que B, de telle sorte que (p-1) divise B!. On&nbsp; consid&egrave;re alors a=g^(B!) mod n, qui doit &ecirc;tre congru &agrave; 1 modulo p, par le petit th&eacute;or&egrave;me de Fermat. Ainsi p divise (a-1) et n, donc le pgcd(a-1,n), s'il est diff&eacute;rent de 1 et n, est un diviseur non trivial de n. On a factoris&eacute; n.&nbsp;&nbsp; </span></p>\n<p><span style=\"font-size: small;\">&Eacute;crire une procedure PollardTest(n,B,g) qui effectue l'algorithme (p-1) de Pollard pour le nombre testeur g.&nbsp; Puis &eacute;crire une procedure Pollard(n,B) qui&nbsp; effectue les tests de Pollard avec tous les testeurs g tels que 1&lt;g&lt;n et s'arr&ecirc;te si elle trouve un facteur de n ou si tous les g possibles ont &eacute;t&eacute; test&eacute;s.&nbsp; Appliquer cette proc&eacute;dure sur n = 139*197 et retrouver p,q. <br /></span></p>"}︡
︠7c598b34-e104-417d-845b-f79db98303a3i︠
%html
<p><span style="font-size: small;">Exercice 9 (*) : "Un groupe est un ensemble muni d'une loi"</span></p>
<p><span style="font-size: small;">Si vous &ecirc;tes arriv&eacute;s l&agrave;, vous avez davantage besoin de faire des maths que de l'info. On veut compter le nombre de groupes finis non isomporhes de taille n. Autrement dit, il s'agit du nombre de choix de lois de groupe diff&eacute;rentes sur [a1,...,an] telles que les groupes obtenus ne sont pas isomorphes. Regarder &agrave; la main les cas 3 et 4. Puis, faites la version facile en testant toutes les op&eacute;rations possibles puis en v&eacute;rifiant que c'est une loi, et ensuite en testant tous les isomorphismes possibles. Enfin, tentez d'am&eacute;liorer l'algorithme en &eacute;vitant les op&eacute;rations inutiles.</span></p>

︡7fe19fe0-7a35-4734-bf3f-c3c0204b6575︡{"html": "<p><span style=\"font-size: small;\">Exercice 9 (*) : \"Un groupe est un ensemble muni d'une loi\"</span></p>\n<p><span style=\"font-size: small;\">Si vous &ecirc;tes arriv&eacute;s l&agrave;, vous avez davantage besoin de faire des maths que de l'info. On veut compter le nombre de groupes finis non isomporhes de taille n. Autrement dit, il s'agit du nombre de choix de lois de groupe diff&eacute;rentes sur [a1,...,an] telles que les groupes obtenus ne sont pas isomorphes. Regarder &agrave; la main les cas 3 et 4. Puis, faites la version facile en testant toutes les op&eacute;rations possibles puis en v&eacute;rifiant que c'est une loi, et ensuite en testant tous les isomorphismes possibles. Enfin, tentez d'am&eacute;liorer l'algorithme en &eacute;vitant les op&eacute;rations inutiles.</span></p>"}︡
